
/*----------------------------------------------------------------------
  Copyright (C) 1997, IGS Technology, Inc.

  Permission is hereby granted to use, copy and modify this software
  only for the purpose of developing IGS Technology related products.

  This software may not be distributed to any party which is not covered
  by IGS Technology Non-Disclosure Agreement (NDA).

  This software is provided "as is" without warranty of any kind,
  either expressed or implied, including but not limited to the implied
  warranties of merchantability and/or fitness for a particular purpose.

  Author: Bo
  ----------------------------------------------------------------------*/

#ifndef _IGS_H
#define _IGS_H

//
// From igsvideo.h 
// Begin 
#define PHILIPS7111       1    /*Philips 7111*/
#define NODECODER         -1   /*No decoder*/

#define PAL               0    /*for PAL system*/
#define NTSC              1    /*for NTSC system*/
#define SECAM             2    /*for SECAM system*/

#define COMPOSITE         0    /*for composite video*/
#define S_VIDEO           1    /*for super VHS*/

#define COLOR_HUE         0
#define COLOR_BRIGHTNESS  1
#define COLOR_SAT         2
#define COLOR_CONTRAST    3
#define COLOR_RED         4
#define COLOR_GREEN       5
#define COLOR_BLUE        6

#define YUV422      0		/* data goes into overlay region is YUV 422 format */
#define RGB565			1		/* data goes into overlay region is RGB 565 format */
#define RGB24				2		/* data goes into overlay region is RGB 24 format */

#define COLORKEY    0    /*Overlayed window is of color keying*/
#define WINDOWKEY   1    /*Overlayed window is of window keying*/
// End
//

#define SUPPORTVUNDERSCAN			1		/* 1: when TV vertical underscan, 
																	 * overlay is also supported
																	 */

#define PCI_FUNCTION_ID				0xB1
#define FIND_PCI_DEVICE				0x02
#define Vender_ID							0x10ea
#define Device_ID							0x2000
//#define READ_CONFIG_unsigned short   0x09

#define XLATTABSIZE						256     /* xlat table size */
#define CVHI									255     /* clamp value hi  */
#define CVLO									0       /* clamp value lo  */

#define NTSC_GarbageLine			3				/* some garbage lines from decoder */
#define PAL_GarbageLine				4
//#define NTSC_SRC_HEIGHT				480
//#define PAL_SRC_HEIGHT				572			
																			/* should be 576, but some extra 
																	 		 * bargage lines
																	 		 */

#define WBPP									2       /* YUV 2bytes/pixels */

#define MAXMPEG1							352

#define P7111Port							0x48

#define ON										1
#define OFF										0

#define TRUE									1
#define FALSE									0

#define X_SCREEN							0
#define Y_SCREEN							1

#define LOWORD(w)	 						((unsigned short)(w))
#define HIWORD(w)	 						((unsigned short)((unsigned long)(w) >> 16))
#define LOBYTE(w)							((unsigned char)(w))
#define HIBYTE(w)							((unsigned char)((unsigned short)(w) >> 8))
#define MulDiv(x, y, z)				((long)((int) x * (int) y) / (int) z)

#define min(x, y)							((x < y) ? x : y)
#define max(x, y)							((x > y) ? x : y)
#define abs(x)								((x > 0) ? x : -x)

#define latU_B 								256*1
#define latU_G 								256*2
#define latV_G 								256*3
#define latV_R 								256*4

#define TIME1	   							100		/* 100=7.5 micro Seconds 
																	 	 * (50 Kbits/sec, I2C max is 100 Kbits/sec
																	 	 */
#define STOPTIME							5000	/* delay after stop cycle */
#define TimeDelay  						30
#define TimeDelay1 						10

#define IGSEXTINDEX						0x3CE
#define IGSEXTDATA						0x3CF
#define CRTINDEX							0x3D4
#define CRTDATA								0x3D5

/*IGS generic IO*/
#define ExtCrtVOver						0x11
#define ExtIRQCtrl						0x12
#define ExtFetch0							0x14
#define ExtFetch1							0x15
#define ExtBusCtrl						0x30
#define WriteBank							0x31
#define ReadBank							0x32
#define ExtBIUCtrl						0x33
#define ExtAttCtrl						0x57
#define ExtMemCtrl2						0x72
#define ExtHidenCtrl					0x73
#define ExtFIFOReg0						0x74
#define ExtFIFOReg1						0x75
#define ExtSeqMisc						0x77
#define ExtChipID0						0x91
#define ExtChipID1						0x92
#define ExtChipID2						0x93
#define ScratchReg0						0x94
#define ExtVClkData0					0xb0
#define ExtVClkData1					0xb1
#define ExtJumper1						0xb5

#define ExtChipData0					0xA1
#define ExtChipData1					0x01
#define ExtChipData2					0x00

/*IGS video IO*/
#define MEMORY_START_L				0xC0
#define MEMORY_START_M				0xC1
#define MEMORY_START_H				0xC2
#define MEMORY_PITCH_L				0xC3
#define MEMORY_PITCH_H				0xC4
#define DEST_RECT_LEFT_L			0xC5
#define DEST_RECT_LEFT_H			0xC6
#define DEST_RECT_RIGHT_L			0xC7
#define DEST_RECT_RIGHT_H			0xC8
#define DEST_RECT_TOP_L				0xC9
#define DEST_RECT_TOP_H				0xCA
#define DEST_RECT_BOTTOM_L		0xCB
#define DEST_RECT_BOTTOM_H		0xCC
#define MEMORY_OFFSET_PHASE		0xCD
#define COLOR_CMP_RED					0xCE
#define COLOR_CMP_GREEN				0xCF
#define COLOR_CMP_BLUE				0xD0
#define DDA_X_INIT_L					0xD1
#define DDA_X_INIT_H					0xD2
#define DDA_X_INC_L						0xD3
#define DDA_X_INC_H						0xD4
#define DDA_Y_INIT_L					0xD5
#define DDA_Y_INIT_H					0xD6
#define DDA_Y_INC_L						0xD7
#define DDA_Y_INC_H						0xD8
#define FIFO_TIMING_CTL_L			0xD9
#define FIFO_TIMING_CTL_H			0xDA
#define VIDEO_FORMAT					0xDB
#define DISP_CTL_I						0xDC
#define FIFO_CTL_I						0xDD
#define MISC_CTL_I						0xDE

#define VIDEO_ROM_UCB4G_HI		0xE5
#define VFAC_CTL_MODE_I				0xE8
#define VFAC_CTL_MODE_II			0xE9
#define VFAC_CTL_MODE_III			0xEA
#define CAPTURE_ADDR_L				0xEB
#define CAPTURE_ADDR_M				0xEC
#define CAPTURE_ADDR_H				0xED
#define CAPTURE_PITCH_L				0xEE
#define CAPTURE_CTL_MISC			0xEF

#define CAPTURE_TEST_CTL			0x43
#define CAPTURE_X2_CTL_I			0x49
#define CAPTURE_H_START_L			0x60
#define CAPTURE_H_START_H			0x61
#define CAPTURE_H_END_L				0x62
#define CAPTURE_H_END_H				0x63
#define CAPTURE_V_START_L			0x64
#define CAPTURE_V_START_H			0x65
#define CAPTURE_V_END_L				0x66
#define CAPTURE_V_END_H				0x67
#define CAPTURE_DDA_X_INIT_L	0x68
#define CAPTURE_DDA_X_INIT_H	0x69
#define CAPTURE_DDA_X_INC_L		0x6A
#define CAPTURE_DDA_X_INC_H		0x6B
#define CAPTURE_DDA_Y_INIT_L	0x6C
#define CAPTURE_DDA_Y_INIT_H	0x6D
#define CAPTURE_DDA_Y_INC_L		0x6E
#define CAPTURE_DDA_Y_INC_H		0x6F
#define CAPTURE_NEW_CTL_I			0x88
#define CAPTURE_NEW_CTL_II		0x89
#define CAPTURE_MODE_I				0xA4
#define CAPTURE_MODE_II				0xA5
#define CAPTURE_TV_CTL				0xAE
#define CAPTURE_BANK_CTL			0xFA

/*for 2nd Overlay Window*/
#define V_SRC_START_LO				0x40
#define V_SRC_START_MI				0x41
#define V_SRC_START_HI				0x42
#define V_SRC_STRIDE_LO				0x43
#define V_SRC_STRIDE_HI				0x44
#define V_SRC_FETCH_LO				0x4D
#define V_SRC_FETCH_HI				0x44
#define V_DST_X1_LO						0x45
#define V_DST_X1_HI						0x46
#define V_DST_X2_LO						0x47
#define V_DST_X2_HI						0x48
#define V_DST_Y1_LO						0x49
#define V_DST_Y1_HI						0x4A
#define V_DST_Y2_LO						0x4B
#define V_DST_Y2_HI						0x4C

/*for Picture in Picture*/
#define CAP_PIP_HSTART_L     	0x80
#define CAP_PIP_HSTART_H     	0x81
#define CAP_PIP_HEND_L       	0x82
#define CAP_PIP_HEND_H       	0x83
#define CAP_PIP_VSTART_L     	0x84
#define CAP_PIP_VSTART_H     	0x85
#define CAP_PIP_VEND_L       	0x86
#define CAP_PIP_VEND_H			 	0x87

/*for source chroma key*/
#define CHROMA_CMP_RED_HI			0x8A
#define CHROMA_CMP_RED_LO			0x8B
#define CHROMA_CMP_GREEN_HI		0x8C
#define CHROMA_CMP_GREEN_LO		0x8D
#define CHROMA_CMP_BLUE_HI		0x8E
#define CHROMA_CMP_BLUE_LO		0x8F

#define YUV_OFS_LO						0xFC
#define YUV_OFS_HI						0xFD

/*
 * Internal used routines
 *
 * The routines will be mostly not called by Applications but
 * are used by libary routines.
 */

/*
 *	Function declarations of "igs.c" 
 */
/*** U T I L I T I E S   F U C T I O N S ***/
void ResetSeq(void);
void Out_Video_Reg(unsigned char bIndex, unsigned char bValue);
void Out_Video_Reg_M(	unsigned char bIndex,
											unsigned char bValue,
											unsigned char bMask);
unsigned char In_Video_Reg (unsigned char bIndex);
unsigned char	ReadReg(unsigned short wReg, unsigned char bIndex);
void IGS_SetFrameFreezeAsync (int OnOff);
int IGS_IsFreezeDone(void);
int Set_Temp_Region(int nDataSize);
int Init_Display_Region(int nMinor, int nDataSize);
int Expand_Display_Region(int nMinor, int nNewDataSize);
void Corel_ScaleDown(int nMinor);
void Corel_PIP1(int nMinor);	/* first kind of PIP */
void Corel_PIP2(int nMinor, int order);		/* 	order=0 background
																							order=1 foreground */
void Corel_Icon(int nMinor);
void Corel_ShiftVideo(int source);
void Corel_DisplayFreeze(int nMinor, int type);	
/* type = 0, selected freeze */
/* type = 1, surrounding freeze */

/*** G E N E R A L   F U N C T I O N S ***/
int		IGS_IsGraphics(void);
void 	IGS_SetRGBKeyColor (unsigned long cref);
int   GetBpp(void);
int		GetCurrentScreenSize(int iScreen);
int		GetVMemSize(void);
int		GetVideoFIFO(void);
void	Change_VideoFIFO(int which);
void 	IGS_InitVideo(void);

/*** C A P T U R E   F U N C T I O N S ***/
void	IGS_SetFreezeVid (int OnOff);
void 	IGS_SetCaptureAddr(void);
void	Set_Capture_Scale(unsigned short wSrcXExt,
												unsigned short wDstXExt,
												unsigned short wSrcYExt,
												unsigned short wDstYExt);
void 	IGS_SetXYMirror(int gwXMirror, int gwYMirror);
void	Set_Capture_addr(unsigned long dwOffAddr);
void 	IGS_FreezeVideo (void);
void 	IGS_UnfreezeVideo (void);
void	IGS_VideoCaptureOn(void);
void	IGS_VideoCaptureOff(void);

/*** V I D E O   O N E   (M A I N) ***/
void 	IGS_VideoOn(void);
void 	IGS_VideoOff(void);
void 	IGS_SetCaptureFormat(unsigned char nFormat);
void 	IGS_SetOverlayFormat(unsigned char nFormat);
void 	IGS_SetScale(	unsigned short wSrcXExt,
										unsigned short wDstXExt,
										unsigned short wSrcYExt,
										unsigned short wDstYExt);
void 	IGS_AdjustVideoWindow(int cx, int cy, int wWinWidth, int wWinHeight);
void 	IGS_SetOverlayWindow(	unsigned short wLeft,
														unsigned short wTop,
														unsigned short wRight,
														unsigned short wBottom);
void 	IGS_SetSrcAddr(	unsigned short wX,
											unsigned short wY,
											unsigned short wPixelWidth,
											unsigned short wMapWidth);
void 	IGS_VideoCleanUp(void);

/*** V I D E O   T W O   (V 2   V I D E O) ***/
void 	IGS_SetSrcAddr_V2(unsigned short wX,
												unsigned short wY,
												unsigned short wPixelWidth,
												unsigned short wMapWidth);
void 	IGS_SetOverlayWindow_V2(unsigned short wLeft,
															unsigned short wTop,	
															unsigned short wRight,
															unsigned short wBottom);
void 	IGS_OverlayOn_V2(void);
void 	IGS_OverlayOff_V2(void);
void 	IGS_VideoCleanUp_V2(void);
void 	IGS_AdjustVideoWindow_V2(int cx, int cy, int wWinWidth, int wWinHeight);
void 	IGS_SetScale_V2(unsigned short wSrcXExt,
											unsigned short wDstXExt,
											unsigned short wSrcYExt,
											unsigned short wDstYExt);
void 	IGS_SetOverlayFormat_V2(unsigned char nFormat);
void	IGS_SetCaptureFormat_V2(unsigned char nFormat);

/*** V I D E O   T H R E E   (X 2   V I D E O) ***/
void	IGS_SetSrcAddr_X2(unsigned short wX,
                        unsigned short wY,
                        unsigned short wPixelWidth,
                        unsigned short wMapWidth);
void	IGS_SetOverlayWindow_X2(unsigned short wLeft,
                              unsigned short wTop,
                              unsigned short wRight,
                              unsigned short wBottom);
void IGS_OverlayOn_X2(void);
void IGS_OverlayOff_X2(void);
void IGS_VideoCleanUp_X2(void);
void IGS_AdjustVideoWindow_X2(int cx, int cy, int wWinWidth, int wWinHeight);
void IGS_SetScale_X2( unsigned short wSrcXExt,
                      unsigned short wDstXExt,
                      unsigned short wSrcYExt,
                      unsigned short wDstYExt);
void IGS_SetOverlayFormat_X2(unsigned char nFormat);
void IGS_SetCaptureFormat_X2(unsigned char nFormat);

/*** P I P   F U N C T I O N S ***/
void IGS_EnablePIP(int OnOff);
void IGS_SetPIPWindow(int x0, int y0, int x1, int y1, 
											int iCaptureW, int iCaptureH);

/*** F U N C T I O N S   N O T   U S E D ***/
#if 0
void	IGS_SetCaptureClip(int gwVideoStandard);
int  	IGS_SetSrcWindowSize(unsigned short wWidth, unsigned short wHeight);
int  	IGS_SetSrcWindowSize_V2(unsigned short wWidth, unsigned short wHeight);
void 	dwSetOffScreenPtr(unsigned long dwL);
void 	dwSetOffScreenPtr_V2(unsigned long dwL);
void	IGS_InitXlatTab (void); 							//YUV->RGB xlat table
int  	IGS_InitParam(void);
void 	IGS_OverlayOn(void);
void 	IGS_OverlayOff(void);
void 	RectTransfer(	char* fpDst,
										char* fpSrc,
										unsigned short wWidth,
										unsigned short wHeight);
int  	GetCurrentScreenSize(int iScreen);
#endif

/* 
 *  Function declarations of "video_color.c"
 */
void InitXlatTab(void);
void YUV422To24RGB(	unsigned char *lpRGBBuf,
										unsigned char *lpYUVBuf,
										int nLineLen);
void ConvertYUVtoRGB24(	char* fpDst,
												char* fpSrc,
												unsigned short wWidth,
												unsigned short wHeight);
void ConvertYUVtoRGB16(	char* fpDst,
												char* fpSrc,
												unsigned short wWidth,
												unsigned short wHeight);
void YUV422To16RGB(	unsigned char *lpRGBBuf,
										unsigned char *lpYUVBuf,
										int nLineLen);

/*
 *  Function declarations of "philips.c"
 */
int DetectDecoder(void);
int InitPhil7111(void);
int readI2C(unsigned char* bValue);
int readOneByte(unsigned char bAddr, 
								unsigned char bSubaddr, 
								unsigned char* bValue);
int writeI2C(unsigned char bVal);
int AcknowledgeMaster(void);
int Acknowledge(void);
int AcknowledgeClk(void);
int Start_Cycle(void);
int Stop_Cycle(void);
int sendOneByte(unsigned char bAddr,
								unsigned char bSubaddr,
								unsigned char bVal);
int sendMoreByte(	unsigned char bAddr,
									unsigned char bSubaddr,
									unsigned char *bValPtr,
									int iCount);

/*
 *  Function declarations of "igscop.c"
 */
void EnableCop();
void SrcCopy(int sx, int sy, int dx, int dy, int w, int h);
void SrcCopy_0(int sx, int sy, int dx, int dy, int w, int h);
void PaintWindow(int x, int y, int w, int h, unsigned long c);
void wait_for_cop_ready(void);
void Set_IGS_Px_Map(int sw, int dw);
void Corel_Set_IGS_Px_Map(int sw, int dw, int pixelsize);
void Corel_Setup_SrcCopy(unsigned long ulSrcPtr, unsigned long ulDstPtr);
void Corel_SrcCopy(int sx, int sy, int dx, int dy, int w, int h);
void Corel_SrcCopy_1(int sx, int sy, int dx, int dy, int w, int h);

/*
 *	Functions declarations of "resolution.c"
 */
void set_resolution(int x_ext, int y_ext);
void SetStandardReg(unsigned char *bPtr);
void SetPartExtReg(unsigned char *bPtr, int iCounter);
void ToggleClock(void);
void EnableChip1(void);
void InitChip1(void);
void SetExtReg(unsigned char *bPtr, int iCounter);
void SetRamDac(unsigned char *bPtr, int iCounter);
void BypassMode(int iOnOff);

#endif /* _IGS_H */
